node {
   def apache_pipeline
   stage('Git checkout') { // for display purposes
      // Get some code from a GitHub repository
      git 'https://gitlab.com/tapas.rwth/apache-test-pipeline.git'
      
   }
   stage('Build') {
      // clean old env
      sh label: '', script: '''docker stop $(docker ps | grep registry.gitlab.com/tapas.rwth/apache-test-pipeline | awk \'{print $1 }\')
      docker images -a | grep registry.gitlab.com/tapas.rwth/apache-test-pipeline | awk \'{print $3}\' | xargs docker rmi -f'''
      //building new iamge
      sh label: '', script: '''docker build -t registry.gitlab.com/tapas.rwth/apache-test-pipeline:build_${BUILD_NUMBER} .
      docker login registry.gitlab.com/tapas.rwth/apache-test-pipeline -u tapas.rwth -p <pwd>
      docker push registry.gitlab.com/tapas.rwth/apache-test-pipeline
      docker run -dit -p 80:80 registry.gitlab.com/tapas.rwth/apache-test-pipeline:build_${BUILD_NUMBER}'''
     
   }
   
   stage('Test') {
       sh label: '', script: '''python2 testcase.py
       docker stop $(docker ps | grep registry.gitlab.com/tapas.rwth/apache-test-pipeline | awk \'{print $1 }\')
       docker images -a | grep registry.gitlab.com/tapas.rwth/apache-test-pipeline | awk \'{print $3}\' | xargs docker rmi -f'''
   }
   stage('Deploy') {
      sh label: '', script: '''docker build -t registry.gitlab.com/tapas.rwth/apache-test-pipeline:latest .
      docker login registry.gitlab.com/tapas.rwth/apache-test-pipeline -u tapas.rwth -p <pwd>
      docker push registry.gitlab.com/tapas.rwth/apache-test-pipeline
      docker run -dit -p 80:80 registry.gitlab.com/tapas.rwth/apache-test-pipeline:latest'''
   } 
}